(in-package :movement-three)

(defun cfg-analysis (transfer merge bottom equal code)
  (let* ((*code* code)
         (outputs (make-hash-table))
         (cfg (code-cfg code))
         (start (aref (cfg-blocks-by-schedule cfg) 0)))
    (flet ((merge-preds (b)
             (let (state (state-present nil))
               (dolist (p (basic-block-predecessors b))
                 (multiple-value-bind (result present) (gethash p outputs)
                   (when present
                     (setf state (if state-present (funcall merge state result) result)
                           state-present t))))
               (if state-present state bottom))))
      (loop with work-list = (list start)
            until (null work-list)
            do (let* ((b (pop work-list))
                      (state (if (eq b start)
                                 bottom
                                 (merge-preds b))))
                 (dolist (i (basic-block-phis b))
                   (setf state (funcall transfer i state)))
                 (dolist (i (basic-block-nodes b))
                   (setf state (funcall transfer i state)))
                 (unless (multiple-value-bind (old present)
                             (gethash b outputs)
                           (and present (funcall equal state old)))
                   (setf (gethash b outputs) state)
                   (dolist (s (basic-block-successors b)) (pushnew s work-list))))))
    outputs))

(defun bb-analysis (transfer bottom code)
  (loop for b across (cfg-blocks-by-schedule (code-cfg code))
        do (loop for n in (basic-block-nodes b)
                 and s = bottom then (funcall transfer n s))))
